X2Go Bug report logs - #285
keyboard layout isn't applied to the session (when resuming)

version graph

Package: x2goserver; Maintainer for x2goserver is X2Go Developers <x2go-dev@lists.x2go.org>; Source for x2goserver is src:x2goserver.

Reported by: "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>

Date: Mon, 5 Aug 2013 00:18:01 UTC

Severity: normal

Tags: confirmed, pending

Found in version 4.0.1.3

Fixed in version 4.0.1.7

Done: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Mon, 05 Aug 2013 00:18:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
New Bug report received and forwarded. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 05 Aug 2013 00:18:01 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.x2go.org (full text, mbox):

From: "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>
To: submit@bugs.x2go.org
Subject: keyboard layout selected in x2go client isn't applied to the session
Date: Mon, 05 Aug 2013 01:45:45 +0200
Package: x2goserver
Version: 4.0.1.3

It seems that the keyboard layout selected in x2go client isn't applied to the session.

I've tracked the issue to "keyboard" blocking directory being created by x2gostartagent script:
if [ "$X2GO_SET_KBD" == "0" ] || [ "$X2GO_KBD_TYPE" != "auto" ]; then
	$X2GO_LIB_PATH/x2gosyslog "$0" "info" "blocking creation of agent's keyboard file ${SESSION_DIR}/keyboard as requested by session startup command"
	mkdir -p ${SESSION_DIR}/keyboard
fi

X2GO_KBD_TYPE contains the actual keyboard type, so its not "auto" and the blocking directory gets created.
I've changed it to "[ "$X2GO_KBD_TYPE" == "auto" ]" and the keyboard layouts gets applied on session startup.

There is also similar code in x2goresume-session:
# set client-side keyboard model, type, variant, etc.
if [ "$X2GO_SET_KBD" != "0" ] && [ "$X2GO_KBD_TYPE" == "auto" ]; then

Here it should probably be "[ "$X2GO_KBD_TYPE" != "null\/null" ]", as few lines earlier the script
will change X2GO_KBD_TYPE to this value when it is set to "auto" or when X2GO_SET_KBD is zero.

Best regards,
Maciej Szmigiero


Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Mon, 05 Aug 2013 10:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 05 Aug 2013 10:18:02 GMT) Full text and rfc822 format available.

Message #10 received at 285@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 285@bugs.x2go.org
Cc: 285-submitter@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#285: keyboard layout selected in x2go client isn't applied to the session
Date: Mon, 05 Aug 2013 12:16:56 +0200
[Message part 1 (text/plain, inline)]
Control: tag -1 confirmed

Hi Maciej,

I have taken a look at this issue this morning and I think in some  
parts you are right, in some parts you are wrong.

On Mo 05 Aug 2013 01:45:45 CEST "Maciej S. Szmigiero" wrote:

> Package: x2goserver
> Version: 4.0.1.3
>
> It seems that the keyboard layout selected in x2go client isn't  
> applied to the session.
>
> I've tracked the issue to "keyboard" blocking directory being  
> created by x2gostartagent script:
> if [ "$X2GO_SET_KBD" == "0" ] || [ "$X2GO_KBD_TYPE" != "auto" ]; then
> 	$X2GO_LIB_PATH/x2gosyslog "$0" "info" "blocking creation of agent's  
> keyboard file ${SESSION_DIR}/keyboard as requested by session  
> startup command"
> 	mkdir -p ${SESSION_DIR}/keyboard
> fi
>
> X2GO_KBD_TYPE contains the actual keyboard type, so its not "auto"  
> and the blocking directory gets created.
> I've changed it to "[ "$X2GO_KBD_TYPE" == "auto" ]" and the keyboard  
> layouts gets applied on session startup.

x2gostartagent: here I do not see an issue. Not that in X2Go Server  
there are three ways to set up your keyboard:

  1) no setup at all (setxkb=false in sessions file)
  2) setup a specific setup (e.g. type=pc105/us, layout=us)
  3) automatic setup (-> type=auto, layout=)

The server-side script ,,x2gosetkeyboard'' is only used for 3).

The keyboard setup for 2) is managed from the client side by issuing  
setxkbmap commands via the open SSH channel.

On x2gostartagent, everything (after testing with PyHoca-GUI and X2Go  
Client) works as expected.

> There is also similar code in x2goresume-session:
> # set client-side keyboard model, type, variant, etc.
> if [ "$X2GO_SET_KBD" != "0" ] && [ "$X2GO_KBD_TYPE" == "auto" ]; then
>
> Here it should probably be "[ "$X2GO_KBD_TYPE" != "null/null" ]", as  
> few lines earlier the script
> will change X2GO_KBD_TYPE to this value when it is set to "auto" or  
> when X2GO_SET_KBD is zero.

For x2goresume-session, however, you dug out a minor issue. This issue  
has been fixed now, see the automatic follow-up mail which will point  
you to the code change in X2Go Git.

Thanks for contributing to X2Go,
Mike


-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Added tag(s) confirmed. Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to 285-submit@bugs.x2go.org. (Mon, 05 Aug 2013 10:18:02 GMT) Full text and rfc822 format available.

Message sent on to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
Bug#285. (Mon, 05 Aug 2013 10:18:02 GMT) Full text and rfc822 format available.

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Mon, 05 Aug 2013 10:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 05 Aug 2013 10:33:02 GMT) Full text and rfc822 format available.

Message #20 received at 285@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 285-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 285@bugs.x2go.org
Subject: X2Go issue (in src:x2goserver) has been marked as pending for release
Date: Mon, 5 Aug 2013 12:18:59 +0200 (CEST)
tag #285 pending
fixed #285 4.0.1.7
thanks

Hello,

X2Go issue #285 (src:x2goserver) reported by you has been
fixed in X2Go Git. You can see the changelog below, and you can
check the diff of the fix at:

    http://code.x2go.org/gitweb?p=x2goserver.git;a=commitdiff;h=afa555f

The issue will most likely be fixed in src:x2goserver (4.0.1.7).

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
commit afa555fcfdb84dcc005a38f7b0644813dde1e625
Author: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Date:   Mon Aug 5 12:18:41 2013 +0200

    Fix automatic keyboard setup (via x2gosetkeyboard) while resuming a session. (Fixes: #285).

diff --git a/debian/changelog b/debian/changelog
index f0269f5..8493262 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -12,6 +12,8 @@ x2goserver (4.0.1.7-0~x2go1) UNRELEASED; urgency=low
       Xsession.options they get symlinked into /etc/x2go. Otherwise Xsession.d
       and Xsession.options are created under /etc/x2go as empty dir/file.
       (Fixes: #278).
+    - Fix automatic keyboard setup (via x2gosetkeyboard) while resuming a session.
+      (Fixes: #285).
   * /debian/control:
     - Update LONG_DESCRIPTIONS.
     - Move xfonts-base from Recommends: field to Depends: field (bin:package


Added tag(s) pending. Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Mon, 05 Aug 2013 10:33:02 GMT) Full text and rfc822 format available.

Marked as fixed in versions 4.0.1.7. Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Mon, 05 Aug 2013 10:33:02 GMT) Full text and rfc822 format available.

Message sent on to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
Bug#285. (Mon, 05 Aug 2013 10:33:03 GMT) Full text and rfc822 format available.

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Mon, 05 Aug 2013 11:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 05 Aug 2013 11:33:02 GMT) Full text and rfc822 format available.

Message #32 received at 285@bugs.x2go.org (full text, mbox):

From: "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Cc: 285@bugs.x2go.org
Subject: Re: Bug#285: [X2Go-Dev] Bug#285: keyboard layout selected in x2go client isn't applied to the session
Date: Mon, 05 Aug 2013 13:13:50 +0200
Hello Mike,

Thanks for a quick look, see also comments below, inlined.

W dniu 05.08.2013 12:16, Mike Gabriel pisze: 
> Hi Maciej,
> 
> I have taken a look at this issue this morning and I think in some parts you are right, in some parts you are wrong.
> 
> On Mo 05 Aug 2013 01:45:45 CEST "Maciej S. Szmigiero" wrote:
> 
(..)
> x2gostartagent: here I do not see an issue. Not that in X2Go Server there are three ways to set up your keyboard:
> 
>   1) no setup at all (setxkb=false in sessions file)
>   2) setup a specific setup (e.g. type=pc105/us, layout=us)
>   3) automatic setup (-> type=auto, layout=)
> 
> The server-side script ,,x2gosetkeyboard'' is only used for 3).
> 
> The keyboard setup for 2) is managed from the client side by issuing setxkbmap commands via the open SSH channel.

I've grepped x2goclient-4.0.1.0 sources and found only setxkbmap call on client side (via "QProcess::startDetached").

There is also remote xmodmap call on Maemo, but it only remaps two keys.

> On x2gostartagent, everything (after testing with PyHoca-GUI and X2Go Client) works as expected.

Unfortunately not for me (that's why I looked into this issue).

(..)
> For x2goresume-session, however, you dug out a minor issue. This issue has been fixed now, see the automatic follow-up mail which will point you to the code change in X2Go Git.

Thanks.
 
> Thanks for contributing to X2Go,
> Mike

Thanks and best regards,
Maciej Szmigiero


Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Mon, 05 Aug 2013 12:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 05 Aug 2013 12:18:02 GMT) Full text and rfc822 format available.

Message #37 received at 285@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>
Cc: 285@bugs.x2go.org, control@bugs.x2go.org
Subject: Re: Bug#285: keyboard layout selected in x2go client isn't applied to the session
Date: Mon, 05 Aug 2013 14:06:15 +0200
[Message part 1 (text/plain, inline)]
clone #285 -1
tag -1 - pending
tag -1 - confirmed
retitle #285 keyboard layout isn't applied to the session (when resuming)
retitle -1 keyboard layout isn't applied to the session (when starting)
thanks

Hi Maciej,

I will clone issue #285, so we have two issues: one for resuming  
(#285), one for starting new sessions.

On Mo 05 Aug 2013 13:13:50 CEST "Maciej S. Szmigiero" wrote:

>> x2gostartagent: here I do not see an issue. Not that in X2Go Server  
>> there are three ways to set up your keyboard:
>>
>>   1) no setup at all (setxkb=false in sessions file)
>>   2) setup a specific setup (e.g. type=pc105/us, layout=us)
>>   3) automatic setup (-> type=auto, layout=)
>>
>> The server-side script ,,x2gosetkeyboard'' is only used for 3).
>>
>> The keyboard setup for 2) is managed from the client side by  
>> issuing setxkbmap commands via the open SSH channel.
>
> I've grepped x2goclient-4.0.1.0 sources and found only setxkbmap  
> call on client side (via "QProcess::startDetached").

Yes, that's where the settings get set...

> There is also remote xmodmap call on Maemo, but it only remaps two keys.
>
>> On x2gostartagent, everything (after testing with PyHoca-GUI and  
>> X2Go Client) works as expected.
>
> Unfortunately not for me (that's why I looked into this issue).

In order to get the new cloned bug (the one that deals with keyboard  
layout while starting X2Go sessions) fixed, please send to me  
(privately):

  your ~/.x2goclient/sessions file (grey-out sensitive information)
  your ~/.x2go/C-<sessionid>/options file (on server-side)
  your ~/.x2go/C-<sessionid>/session.log

Thanks,
Mike



-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Bug 285 cloned as bug 286 Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Mon, 05 Aug 2013 12:18:02 GMT) Full text and rfc822 format available.

Changed Bug title to 'keyboard layout isn't applied to the session (when resuming)' from 'keyboard layout selected in x2go client isn't applied to the session' Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Mon, 05 Aug 2013 12:18:02 GMT) Full text and rfc822 format available.

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#285; Package x2goserver. (Fri, 22 Nov 2013 21:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Fri, 22 Nov 2013 21:03:02 GMT) Full text and rfc822 format available.

Message #46 received at 285@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 285-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 285@bugs.x2go.org
Subject: X2Go issue (in src:x2goserver) has been marked as closed
Date: Fri, 22 Nov 2013 21:59:27 +0100 (CET)
close #285
thanks

Hello,

we are very hopeful that X2Go issue #285 reported by you
has been resolved in the new release (4.0.1.7) of the
X2Go source project »src:x2goserver«.

You can view the complete changelog entry of src:x2goserver (4.0.1.7)
below, and you can use the following link to view all the code changes
between this and the last release of src:x2goserver.

    http://code.x2go.org/gitweb?p=x2goserver.git;a=commitdiff;h=447e68e8b82ea4b14e5072e57a0fbc82ef32d687;hp=2d19587c215d49048b6295d87c06c452939a1b8b

If you feel that the issue has not been resolved satisfyingly, feel
free to reopen this bug report or submit a follow-up report with
further observations described based on the new released version
of src:x2goserver.

Thanks a lot for contributing to X2Go!!!

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
X2Go Component: src:x2goserver
Version: 4.0.1.7
Status: RELEASE
Date: Fri, 22 Nov 2013 21:58:27 +0100
Fixes: 276 278 285 305 310 331
Changes: 
 x2goserver (4.0.1.7) RELEASED; urgency=low
 .
   [ Orion Poplawski ]
   * New upstream version (4.0.1.7):
     - Install Xsession file as executable, make Xsession.d directory location
       configurable during build process, do not create unused Xsession.options.
       (Fixes: #278).
 .
   [ Mike Gabriel ]
   * New upstream version (4.0.1.7):
     - Fine-tune x2goserver-xsession/Makefile: if /etc/X11 has Xsession.d and/or
       Xsession.options they get symlinked into /etc/x2go. Otherwise Xsession.d
       and Xsession.options are created under /etc/x2go as empty dir/file.
       (Fixes: #278).
     - Fix automatic keyboard setup (via x2gosetkeyboard) while resuming a
       session. (Fixes: #285).
     - Provide sudoers.d/x2goserver file that allows sudoed commands under
       KDE (by pertaining the env var QT_GRAPHICSSYSTEM. (Fixes: #276).
     - With PostgreSQL as session db backend, prevent the root user from
       launching sessions. Also, prevent x2gouser_root from being added as a
       PostgreSQL user. (Fixes: #310).
     - Execute DB status changes as late as possible during suspend / terminate.
     - Start/resume rootless sessions without geometry parameter. Esp. using
       X2GO_GEOMETRY=fullscreen for rootless sessions lead to an extra 1x1 px
       session window (nxagentCreateIconWindow in nxagent's Window.c).
     - Typo fix in x2goruncommand (for MATE session startup).
   * debian/control:
     + Update LONG_DESCRIPTIONS.
     + Raise Standards: to 3.9.4 (no changes needed).
     + Move xfonts-base to Recommends: field of bin:package x2goserver.
   * debian/x2goserver.init:
     + Make init script LSB compliant.
 .
   [ Helmer Teles ]
   * New upstream version (4.0.1.7):
     - Make umask that is used when mounting client-side folders via SSHFS
       configurable in x2goserver.conf. (Fixes: #331).
 .
   [ Jürgen Hötzel ]
   * New upstream version (4.0.1.7):
     - Use bash-builtin 'type' instead of to be avoided 'which'. (Fixes: #305).
 .
   [ Oleksandr Shneyder ]
   * New upstream version (4.0.0.6):
     - Fix x2goruncommand: "type -P $cmd" can create new lines in EXEC
       variable if command have the arguments wich have same names as existing
       commands, for example "rdesktop -k nl" -> "/usr/bin/rdesktop\n/usr/bin/nl".
       Now we splitting $cmd and taking only first part.


Marked Bug as done Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Fri, 22 Nov 2013 21:03:05 GMT) Full text and rfc822 format available.

Notification sent to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
Bug acknowledged by developer. (Fri, 22 Nov 2013 21:03:05 GMT) Full text and rfc822 format available.

Message sent on to "Maciej S. Szmigiero" <mail@maciej.szmigiero.name>:
Bug#285. (Fri, 22 Nov 2013 21:03:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.x2go.org> to internal_control@bugs.x2go.org. (Sat, 21 Dec 2013 06:24:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


X2Go Developers <owner@bugs.x2go.org>. Last modified: Sat May 25 11:08:26 2019; Machine Name: ymir.das-netzwerkteam.de

X2Go Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.